--- /dev/null
+
+# mlp-mnist is an implementation of a multi-layer neural network.
+#
+# Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+# Written by Francois Fleuret <francois.fleuret@idiap.ch>
+#
+# This file is part of mlp-mnist.
+#
+# mlp-mnist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 3 as
+# published by the Free Software Foundation.
+#
+# mlp-mnist is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+
+ifeq ($(DEBUG),yes)
+ CXXFLAGS = -Wall -g
+else
+ # Optimized compilation
+ CXXFLAGS = -Wall -ffast-math -fcaller-saves -finline-functions -funroll-all-loops -O3
+endif
+
+all: ann
+
+ann: ann.o misc.o images.o neural.o
+ $(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)
+
+Makefile.depend: *.h *.cc Makefile
+ $(CC) -M *.cc > Makefile.depend
+
+clean:
+ \rm ann *.o Makefile.depend
+
+archive:
+ cd .. ; tar zcvf mlp-mnist.tgz mlp-mnist/{*.{cc,h,txt,sh},Makefile}
+
+-include Makefile.depend
--- /dev/null
+
+You can run the whole script with "./doit --download-mnist" or just
+"./doit.sh" if you already have the MNIST database in the current
+directory.
+
+You should get the following output (this takes a few hours on a
+1.2Ghz Pentium-M):
+
+----------------------------------------------------------------------
+Loading the data file ... done.
+Database contains 60000 images of resolution 28x28 divided into 10 objects.
+Creating a new network (layers of sizes 784 200 10).
+Training the network with 20000 training and 20000 validation examples.
+0 TRAINING 12235.8 (8.58%) TESTING 13030 (9.405%)
+1 TRAINING 8839.31 (6.69%) TESTING 10132.9 (7.71%)
+2 TRAINING 6502.38 (4.575%) TESTING 8268.75 (6.235%)
+3 TRAINING 5656.71 (3.975%) TESTING 7637.6 (5.75%)
+4 TRAINING 5456.68 (3.56%) TESTING 7683.5 (5.6%) [1]
+5 TRAINING 4167.26 (2.64%) TESTING 6557.84 (4.82%)
+6 TRAINING 4320.34 (2.7%) TESTING 6796.09 (4.89%) [2]
+7 TRAINING 3725.38 (2.435%) TESTING 6307.99 (4.52%)
+8 TRAINING 3946.58 (2.49%) TESTING 6614.6 (4.53%) [3]
+9 TRAINING 3773.16 (2.24%) TESTING 6698.8 (4.67%) [4]
+10 TRAINING 3485.74 (2.13%) TESTING 6539.64 (4.54%)
+11 TRAINING 5903.21 (3.53%) TESTING 8881.58 (5.905%) [5]
+12 TRAINING 3165.84 (1.89%) TESTING 6366.87 (4.385%)
+13 TRAINING 3288.64 (2%) TESTING 6520.78 (4.5%) [6]
+14 TRAINING 2849.94 (1.615%) TESTING 6201.43 (4.215%)
+15 TRAINING 2693.19 (1.555%) TESTING 5991.35 (4.235%)
+16 TRAINING 2827.86 (1.575%) TESTING 6181.83 (4.235%) [7]
+17 TRAINING 2374.73 (1.355%) TESTING 5668.65 (3.77%)
+18 TRAINING 2194.12 (1.255%) TESTING 5572.82 (3.705%)
+19 TRAINING 2114.23 (1.155%) TESTING 5587.74 (3.71%) [8]
+20 TRAINING 1909.78 (1.15%) TESTING 5377.6 (3.64%)
+21 TRAINING 3064.62 (1.705%) TESTING 6642.78 (4.36%) [9]
+22 TRAINING 1832.23 (1.04%) TESTING 5386.12 (3.575%)
+23 TRAINING 1695.47 (0.95%) TESTING 5342.3 (3.61%)
+24 TRAINING 1699.28 (0.935%) TESTING 5331.84 (3.46%)
+25 TRAINING 1478.36 (0.835%) TESTING 5075.09 (3.335%)
+26 TRAINING 1528.62 (0.865%) TESTING 5221.1 (3.41%) [10]
+Saving network simple.mlp ... done.
+Loading the data file ... done.
+Database contains 10000 images of resolution 28x28 divided into 10 objects.
+Loading network simple.mlp ... done (layers of sizes 784 200 10)
+Error rate 2599.54 (3.42%)
+----------------------------------------------------------------------
+
+The computation produces a file simple.mlp containing the learnt
+perceptron.
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+// LeCun et al. 1998:
+
+// 2-layer NN, 300 hidden units, mean square error 4.70%
+// 2-layer NN, 1000 hidden units 4.50%
+// 3-layer NN, 300+100 hidden units 3.05%
+// 3-layer NN, 500+150 hidden units 2.95%
+
+/*********************************************************************
+
+ This program, trained on 20,000 (+ 20,000 for the stopping
+ criterion), tested on the 10,000 of the MNIST test set 100 hidden
+ neurons, basic network, 3.48%
+
+ TRAINING
+
+ ./ann --nb-training-examples 20000 --nb-validation-examples 20000 \
+ --mlp-structure 784,200,10 \
+ --data-files ${DATA_DIR}/train-images-idx3-ubyte ${DATA_DIR}/train-labels-idx1-ubyte \
+ --save-mlp simple.mlp
+
+ TEST
+
+ ./ann --load-mlp simple.mlp \
+ --data-files ${DATA_DIR}/t10k-images-idx3-ubyte ${DATA_DIR}/t10k-labels-idx1-ubyte \
+ --nb-test-examples 10000
+
+*********************************************************************/
+
+#include <iostream>
+#include <fstream>
+#include <cmath>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+using namespace std;
+
+#include "images.h"
+#include "neural.h"
+
+#define SMALL_BUFFER_SIZE 1024
+
+//////////////////////////////////////////////////////////////////////
+// Global Variables
+//////////////////////////////////////////////////////////////////////
+
+int nb_experiment = 0;
+int nb_training_examples = 0;
+int nb_validation_examples = 0;
+int nb_test_examples = 0;
+bool save_data = false;
+
+char images_filename[SMALL_BUFFER_SIZE] = "\0";
+char labels_filename[SMALL_BUFFER_SIZE] = "\0";
+char opt_load_filename[SMALL_BUFFER_SIZE] = "\0";
+char opt_save_filename[SMALL_BUFFER_SIZE] = "\0";
+char opt_layer_sizes[SMALL_BUFFER_SIZE] = "\0";
+
+char *next_word(char *buffer, char *r, int buffer_size) {
+ char *s;
+ s = buffer;
+ if(r != NULL)
+ {
+ if(*r == '"') {
+ r++;
+ while((*r != '"') && (*r != '\0') &&
+ (s<buffer+buffer_size-1))
+ *s++ = *r++;
+ if(*r == '"') r++;
+ } else {
+ while((*r != '\r') && (*r != '\n') && (*r != '\0') &&
+ (*r != '\t') && (*r != ' ') && (*r != ',') &&
+ (s<buffer+buffer_size-1))
+ *s++ = *r++;
+ }
+
+ while((*r == ' ') || (*r == '\t') || (*r == ',')) r++;
+ if((*r == '\0') || (*r=='\r') || (*r=='\n')) r = NULL;
+ }
+ *s = '\0';
+ return r;
+}
+
+//////////////////////////////////////////////////////////////////////
+// Simple routine to check we have enough parameters
+//////////////////////////////////////////////////////////////////////
+
+void check_opt(int argc, char **argv, int n_opt, int n, const char *help) {
+ if(n_opt + n >= argc) {
+ cerr << "Missing argument for " << argv[n_opt] << ".\n";
+ cerr << "Expecting " << help << ".\n";
+ exit(1);
+ }
+}
+
+void print_help_and_exit(int e) {
+ cout << "ANN. Written by François Fleuret.\n";
+ cout << "$Id: ann.cc,v 1.1 2005-12-13 17:19:11 fleuret Exp $\n";
+ cout<< "\n";
+ exit(e);
+}
+
+int main(int argc, char **argv) {
+
+ if(argc == 1) print_help_and_exit(1);
+
+ nice(10);
+
+ // Parsing the command line parameters ///////////////////////////////
+
+ int i = 1;
+
+ while(i < argc) {
+
+ if(argc == 1 || strcmp(argv[i], "--help") == 0) print_help_and_exit(0);
+
+ else if(strcmp(argv[i], "--data-files") == 0) {
+ check_opt(argc, argv, i, 2, "<string: pixel filename> <string: label filename>");
+ strncpy(images_filename, argv[i+1], SMALL_BUFFER_SIZE);
+ strncpy(labels_filename, argv[i+2], SMALL_BUFFER_SIZE);
+ i += 3;
+ }
+
+ else if(strcmp(argv[i], "--load-mlp") == 0) {
+ check_opt(argc, argv, i, 1, "<string: mlp filename>");
+ strncpy(opt_load_filename, argv[i+1], SMALL_BUFFER_SIZE);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--mlp-structure") == 0) {
+ check_opt(argc, argv, i, 1, "<int: input layer size>,<int: first hidden layer size>,[...,]<int: output layer size>");
+ strncpy(opt_layer_sizes, argv[i+1], SMALL_BUFFER_SIZE);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--save-mlp") == 0) {
+ check_opt(argc, argv, i, 1, "<string: mlp filename>");
+ strncpy(opt_save_filename, argv[i+1], SMALL_BUFFER_SIZE);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--nb-experiment") == 0) {
+ check_opt(argc, argv, i, 1, "<int: number of the experiment>");
+ nb_experiment = atoi(argv[i+1]);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--nb-training-examples") == 0) {
+ check_opt(argc, argv, i, 1, "<int: number of examples for the training>");
+ nb_training_examples = atoi(argv[i+1]);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--nb-validation-examples") == 0) {
+ check_opt(argc, argv, i, 1, "<int: number of examples for the validation>");
+ nb_validation_examples = atoi(argv[i+1]);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--nb-test-examples") == 0) {
+ check_opt(argc, argv, i, 1, "<int: number of examples for the test>");
+ nb_test_examples = atoi(argv[i+1]);
+ i += 2;
+ }
+
+ else if(strcmp(argv[i], "--save-data") == 0) {
+ save_data = true;
+ i++;
+ }
+
+ else {
+ cerr << "Unknown option " << argv[i] << "\n";
+ print_help_and_exit(1);
+ }
+ }
+
+ ImageSet image_set;
+ cout << "Loading the data file ..."; cout.flush();
+ image_set.load_mnist_format(images_filename, labels_filename);
+ cout << " done.\n"; cout.flush();
+
+ cout << "Database contains " << image_set.nb_pics()
+ << " images of resolution " << image_set.width() << "x" << image_set.height()
+ << " divided into " << image_set.nb_obj() << " objects.\n";
+
+ srand48(nb_experiment);
+
+ int nb_layers = 0;
+ int *layer_sizes = 0;
+
+ if(opt_layer_sizes[0]) {
+ char *s = opt_layer_sizes;
+ char token[SMALL_BUFFER_SIZE];
+ while(s) { s = next_word(token, s, SMALL_BUFFER_SIZE); nb_layers++; }
+
+ if(nb_layers < 2) {
+ cerr << "Need at least two layers.\n";
+ exit(1);
+ }
+
+ layer_sizes = new int[nb_layers];
+ s = opt_layer_sizes;
+ int n = 0;
+ while(s) { s = next_word(token, s, SMALL_BUFFER_SIZE); layer_sizes[n++] = atoi(token); }
+ }
+
+ // Loading or creating a perceptron from scratch /////////////////////
+
+ MultiLayerPerceptron *mlp = 0;
+
+ if(opt_load_filename[0]) {
+
+ ifstream stream(opt_load_filename);
+ if(stream.fail()) {
+ cerr << "Can not read " << opt_load_filename << ".\n";
+ exit(1);
+ }
+
+ cout << "Loading network " << opt_load_filename << " ... "; cout.flush();
+ mlp = new MultiLayerPerceptron(stream);
+ cout << "done (layers of sizes";
+ for(int l = 0; l < mlp->nb_layers(); l++) cout << " " << mlp->layer_size(l);
+ cout << ")\n"; cout.flush();
+
+ } else if(nb_layers > 0) {
+
+ if(layer_sizes[0] != image_set.width() * image_set.height() ||
+ layer_sizes[nb_layers-1] != image_set.nb_obj()) {
+ cerr << "For this data set, the input layer has to be of size " << image_set.width() * image_set.height() << ",\n";
+ cerr << "and the output has to be of size " << image_set.nb_obj() << ".\n";
+ exit(1);
+ }
+
+ cout << "Creating a new network (layers of sizes";
+ for(int i = 0; i < nb_layers; i++) cout << " " << layer_sizes[i];
+ cout << ").\n";
+
+ mlp = new MultiLayerPerceptron(nb_layers, layer_sizes);
+ mlp->init_random_weights(1e-1);
+ }
+
+ // Training the perceptron ///////////////////////////////////////////
+
+ ImageSet training_set, validation_set, test_set;
+
+ if(nb_training_examples > 0)
+ training_set.extract_unused_pictures(image_set, nb_training_examples);
+
+ if(nb_validation_examples > 0)
+ validation_set.extract_unused_pictures(image_set, nb_validation_examples);
+
+ if(save_data && mlp) mlp->save_data();
+
+ if(nb_training_examples > 0) {
+ if(validation_set.nb_pics() == 0) {
+ cerr << "We need validation pictures for training.\n";
+ exit(1);
+ }
+ cout << "Training the network with " << nb_training_examples << " training and " << nb_validation_examples << " validation examples.\n"; cout.flush();
+ mlp->train(&training_set, &validation_set);
+ }
+
+ // Saving the perceptron /////////////////////////////////////////////
+
+ if(opt_save_filename[0]) {
+ if(!mlp) {
+ cerr << "No perceptron to save.\n";
+ exit(1);
+ }
+
+ ofstream stream(opt_save_filename);
+ if(stream.fail()) {
+ cerr << "Can not write " << opt_save_filename << ".\n";
+ exit(1);
+ }
+
+ cout << "Saving network " << opt_save_filename << " ... "; cout.flush();
+ mlp->save(stream);
+ cout << "done.\n"; cout.flush();
+ }
+
+ // Testing the perceptron ////////////////////////////////////////////
+
+ if(nb_test_examples > 0) {
+ test_set.extract_unused_pictures(image_set, nb_test_examples);
+ cout << "Error rate " << mlp->error(&test_set) << " (" << mlp->classification_error(&test_set)*100 << "%)\n";
+
+ // This is to test the analytical gradient
+ // scalar_t gradient[mlp->nb_weights()], numerical_gradient[mlp->nb_weights()];
+ // mlp->compute_gradient(&test_set, gradient);
+ // mlp->compute_numerical_gradient(&test_set, numerical_gradient);
+ // for(int i = 0; i < mlp->nb_weights(); i++) cout << "TEST " << gradient[i] << " " << numerical_gradient[i] << "\n";
+ }
+
+ // Flushing the log //////////////////////////////////////////////////
+
+ delete[] layer_sizes;
+}
--- /dev/null
+#!/bin/bash
+
+# mlp-mnist is an implementation of a multi-layer neural network.
+#
+# Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+# Written by Francois Fleuret <francois.fleuret@idiap.ch>
+#
+# This file is part of mlp-mnist.
+#
+# mlp-mnist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 3 as
+# published by the Free Software Foundation.
+#
+# mlp-mnist is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+
+make -k ann
+
+if [[ $1 == "--download-mnist" ]]; then
+ for f in train-images-idx3-ubyte train-labels-idx1-ubyte t10k-images-idx3-ubyte t10k-labels-idx1-ubyte; do
+ if [[ ! -f "./$f" ]]; then
+ echo "Could not find $f, downloading it."
+ wget http://yann.lecun.com/exdb/mnist/$f.gz
+ gunzip $f.gz
+ fi
+ done
+fi
+
+for f in train-images-idx3-ubyte train-labels-idx1-ubyte t10k-images-idx3-ubyte t10k-labels-idx1-ubyte; do
+ if [[ -f "./$f" ]]; then
+ echo "Found $f, good."
+ else
+ echo "File $f is missing. Try $0 --download-mnist."
+ exit 1
+ fi
+done
+
+./ann --nb-training-examples 20000 --nb-validation-examples 20000 \
+ --mlp-structure 784,200,10 \
+ --data-files ./train-images-idx3-ubyte ./train-labels-idx1-ubyte \
+ --save-mlp simple.mlp
+
+./ann --load-mlp simple.mlp \
+ --data-files ./t10k-images-idx3-ubyte ./t10k-labels-idx1-ubyte \
+ --nb-test-examples 10000
--- /dev/null
+ GNU GENERAL PUBLIC LICENSE
+ Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+ Preamble
+
+ The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+ The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works. By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users. We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors. You can apply it to
+your programs, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+ To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights. Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+ For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received. You must make sure that they, too, receive
+or can get the source code. And you must show them these terms so they
+know their rights.
+
+ Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+ For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software. For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+ Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so. This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software. The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable. Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products. If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+ Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary. To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+ The precise terms and conditions for copying, distribution and
+modification follow.
+
+ TERMS AND CONDITIONS
+
+ 0. Definitions.
+
+ "This License" refers to version 3 of the GNU General Public License.
+
+ "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+ "The Program" refers to any copyrightable work licensed under this
+License. Each licensee is addressed as "you". "Licensees" and
+"recipients" may be individuals or organizations.
+
+ To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy. The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+ A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+ To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy. Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+ To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies. Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+ An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License. If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+ 1. Source Code.
+
+ The "source code" for a work means the preferred form of the work
+for making modifications to it. "Object code" means any non-source
+form of a work.
+
+ A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+ The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form. A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+ The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities. However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work. For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+ The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+ The Corresponding Source for a work in source code form is that
+same work.
+
+ 2. Basic Permissions.
+
+ All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met. This License explicitly affirms your unlimited
+permission to run the unmodified Program. The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work. This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+ You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force. You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright. Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+ Conveying under any other circumstances is permitted solely under
+the conditions stated below. Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+ 3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+ No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+ When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+ 4. Conveying Verbatim Copies.
+
+ You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+ You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+ 5. Conveying Modified Source Versions.
+
+ You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+ a) The work must carry prominent notices stating that you modified
+ it, and giving a relevant date.
+
+ b) The work must carry prominent notices stating that it is
+ released under this License and any conditions added under section
+ 7. This requirement modifies the requirement in section 4 to
+ "keep intact all notices".
+
+ c) You must license the entire work, as a whole, under this
+ License to anyone who comes into possession of a copy. This
+ License will therefore apply, along with any applicable section 7
+ additional terms, to the whole of the work, and all its parts,
+ regardless of how they are packaged. This License gives no
+ permission to license the work in any other way, but it does not
+ invalidate such permission if you have separately received it.
+
+ d) If the work has interactive user interfaces, each must display
+ Appropriate Legal Notices; however, if the Program has interactive
+ interfaces that do not display Appropriate Legal Notices, your
+ work need not make them do so.
+
+ A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit. Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+ 6. Conveying Non-Source Forms.
+
+ You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+ a) Convey the object code in, or embodied in, a physical product
+ (including a physical distribution medium), accompanied by the
+ Corresponding Source fixed on a durable physical medium
+ customarily used for software interchange.
+
+ b) Convey the object code in, or embodied in, a physical product
+ (including a physical distribution medium), accompanied by a
+ written offer, valid for at least three years and valid for as
+ long as you offer spare parts or customer support for that product
+ model, to give anyone who possesses the object code either (1) a
+ copy of the Corresponding Source for all the software in the
+ product that is covered by this License, on a durable physical
+ medium customarily used for software interchange, for a price no
+ more than your reasonable cost of physically performing this
+ conveying of source, or (2) access to copy the
+ Corresponding Source from a network server at no charge.
+
+ c) Convey individual copies of the object code with a copy of the
+ written offer to provide the Corresponding Source. This
+ alternative is allowed only occasionally and noncommercially, and
+ only if you received the object code with such an offer, in accord
+ with subsection 6b.
+
+ d) Convey the object code by offering access from a designated
+ place (gratis or for a charge), and offer equivalent access to the
+ Corresponding Source in the same way through the same place at no
+ further charge. You need not require recipients to copy the
+ Corresponding Source along with the object code. If the place to
+ copy the object code is a network server, the Corresponding Source
+ may be on a different server (operated by you or a third party)
+ that supports equivalent copying facilities, provided you maintain
+ clear directions next to the object code saying where to find the
+ Corresponding Source. Regardless of what server hosts the
+ Corresponding Source, you remain obligated to ensure that it is
+ available for as long as needed to satisfy these requirements.
+
+ e) Convey the object code using peer-to-peer transmission, provided
+ you inform other peers where the object code and Corresponding
+ Source of the work are being offered to the general public at no
+ charge under subsection 6d.
+
+ A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+ A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling. In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage. For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product. A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+ "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source. The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+ If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information. But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+ The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed. Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+ Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+ 7. Additional Terms.
+
+ "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law. If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+ When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it. (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.) You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+ Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+ a) Disclaiming warranty or limiting liability differently from the
+ terms of sections 15 and 16 of this License; or
+
+ b) Requiring preservation of specified reasonable legal notices or
+ author attributions in that material or in the Appropriate Legal
+ Notices displayed by works containing it; or
+
+ c) Prohibiting misrepresentation of the origin of that material, or
+ requiring that modified versions of such material be marked in
+ reasonable ways as different from the original version; or
+
+ d) Limiting the use for publicity purposes of names of licensors or
+ authors of the material; or
+
+ e) Declining to grant rights under trademark law for use of some
+ trade names, trademarks, or service marks; or
+
+ f) Requiring indemnification of licensors and authors of that
+ material by anyone who conveys the material (or modified versions of
+ it) with contractual assumptions of liability to the recipient, for
+ any liability that these contractual assumptions directly impose on
+ those licensors and authors.
+
+ All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10. If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term. If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+ If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+ Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+ 8. Termination.
+
+ You may not propagate or modify a covered work except as expressly
+provided under this License. Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+ However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+ Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+ Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License. If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+ 9. Acceptance Not Required for Having Copies.
+
+ You are not required to accept this License in order to receive or
+run a copy of the Program. Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance. However,
+nothing other than this License grants you permission to propagate or
+modify any covered work. These actions infringe copyright if you do
+not accept this License. Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+ 10. Automatic Licensing of Downstream Recipients.
+
+ Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License. You are not responsible
+for enforcing compliance by third parties with this License.
+
+ An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations. If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+ You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License. For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+ 11. Patents.
+
+ A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based. The
+work thus licensed is called the contributor's "contributor version".
+
+ A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version. For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+ Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+ In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement). To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+ If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients. "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+ If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+ A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License. You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+ Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+ 12. No Surrender of Others' Freedom.
+
+ If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all. For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+ 13. Use with the GNU Affero General Public License.
+
+ Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work. The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+ 14. Revised Versions of this License.
+
+ The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time. Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+ Each version is given a distinguishing version number. If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation. If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+ If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+ Later license versions may give you additional or different
+permissions. However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+ 15. Disclaimer of Warranty.
+
+ THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+ 16. Limitation of Liability.
+
+ IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+ 17. Interpretation of Sections 15 and 16.
+
+ If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+ END OF TERMS AND CONDITIONS
+
+ How to Apply These Terms to Your New Programs
+
+ If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+ To do so, attach the following notices to the program. It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+ <one line to give the program's name and a brief idea of what it does.>
+ Copyright (C) <year> <name of author>
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+ If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+ <program> Copyright (C) <year> <name of author>
+ This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+ This is free software, and you are welcome to redistribute it
+ under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License. Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+ You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+ The GNU General Public License does not permit incorporating your program
+into proprietary programs. If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library. If this is what you want to do, use the GNU Lesser General
+Public License instead of this License. But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include "images.h"
+#include <stdlib.h>
+
+PixelMaps::PixelMaps(int size) : _nb_ref(0),_core(new unsigned char[size]) {}
+PixelMaps::~PixelMaps() { delete[] _core; }
+PixelMaps *PixelMaps::add_ref() { _nb_ref++; return this; }
+void PixelMaps::del_ref() { _nb_ref--; if(_nb_ref == 0) delete this; }
+
+const unsigned int mnist_pictures_magic = 0x00000803;
+const unsigned int mnist_labels_magic = 0x00000801;
+
+inline unsigned int read_high_endian_int(istream &is) {
+ unsigned int result;
+ char *s = (char *) &result;
+ char c;
+ is.read(s, sizeof(result));
+ c = s[0]; s[0] = s[3]; s[3] = c;
+ c = s[1]; s[1] = s[2]; s[2] = c;
+ return result;
+}
+
+ImageSet::ImageSet() : _nb_pics(-1), _nb_obj(0), _width(-1), _height(-1),
+ _pixel_maps(0), _pixels(0), _labels(0), _used_picture(0) { }
+
+ImageSet::~ImageSet() {
+ if(_pixel_maps) _pixel_maps->del_ref();
+ delete[] _pixels;
+ delete[] _labels;
+ delete[] _used_picture;
+}
+
+void ImageSet::reset_used_pictures() {
+ for(int p = 0; p < _nb_pics; p++) _used_picture[p] = false;
+}
+
+int ImageSet::nb_unused_pictures() {
+ int n = 0;
+ for(int p = 0; p < _nb_pics; p++) if(!_used_picture[p]) n++;
+ return n;
+}
+
+int ImageSet::pick_unused_picture() {
+ int m;
+ do { m = int(drand48() * _nb_pics); } while(_used_picture[m]);
+ _used_picture[m] = true;
+ return m;
+}
+
+void ImageSet::extract_unused_pictures(ImageSet &is, int nb) {
+ if(nb > is.nb_unused_pictures()) {
+ cerr << "Trying to extract " << nb << " pictures from a set of " << is.nb_unused_pictures() << "\n";
+ exit(1);
+ }
+
+ _nb_pics = nb;
+ _width = is._width;
+ _height = is._height;
+ _nb_obj = is._nb_obj;
+ _pixel_maps = is._pixel_maps->add_ref();
+ _pixels = new unsigned char *[_nb_pics];
+ _labels = new unsigned char[_nb_pics];
+ _used_picture = new bool[_nb_pics];
+ for(int n = 0; n < _nb_pics; n++) {
+ int m = is.pick_unused_picture();
+ _pixels[n] = is._pixels[m];
+ _labels[n] = is._labels[m];
+ }
+
+ reset_used_pictures();
+}
+
+void ImageSet::load_mnist_format(char *picture_file_name, char *label_file_name) {
+ unsigned int magic;
+
+ ifstream picture_is(picture_file_name);
+
+ if(picture_is.fail()) {
+ cerr << "Can not open file [" << picture_file_name << "].\n";
+ exit(1);
+ }
+
+ magic = read_high_endian_int(picture_is);
+ if(magic != mnist_pictures_magic) {
+ cerr << "Invalid magic for picture, file [" << picture_file_name << "] number [" << magic << "]\n";
+ exit(1);
+ }
+
+ _nb_pics = read_high_endian_int(picture_is);
+ _width = read_high_endian_int(picture_is);
+ _height = read_high_endian_int(picture_is);
+
+ ifstream label_is(label_file_name);
+ if(label_is.fail()) {
+ cerr << "Can not open file [" << label_file_name << "].\n";
+ exit(1);
+ }
+
+ magic = read_high_endian_int(label_is);
+ if(magic != mnist_labels_magic) {
+ cerr << "Invalid magic for labels, file [" << label_file_name << "] number [" << magic << "]\n";
+ exit(1);
+ }
+
+ int nb_pics_labels = read_high_endian_int(label_is);
+
+ if(nb_pics_labels != _nb_pics) {
+ cerr << "Inconsistency between the number of pictures in [" << picture_file_name << "] (" << _nb_pics << ")"
+ << " and the number of labels in [" << label_file_name << "] (" << nb_pics_labels << ").\n";
+ exit(1);
+ }
+
+ PixelMaps *pm = new PixelMaps(_nb_pics * _width * _height);
+ _pixel_maps = pm->add_ref();
+ _pixels = new unsigned char *[_nb_pics];
+ _labels = new unsigned char[_nb_pics];
+ _used_picture = new bool[_nb_pics];
+
+ picture_is.read((char *) _pixel_maps->_core, _nb_pics * _width * _height);
+ label_is.read((char *) _labels, _nb_pics);
+
+ for(int i = 0; i < _nb_pics * _width * _height; i++) _pixel_maps->_core[i] = 255 - _pixel_maps->_core[i];
+
+ _nb_obj = 0;
+ for(int n = 0; n < _nb_pics; n++) {
+ _pixels[n] = _pixel_maps->_core + n * _width * _height;
+ if(_labels[n] > _nb_obj) _nb_obj = _labels[n];
+ }
+ _nb_obj++;
+
+ reset_used_pictures();
+}
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+// $Id: images.h,v 1.1 2005-12-13 17:19:11 fleuret Exp $
+
+#ifndef IMAGES_H
+#define IMAGES_H
+
+#include <iostream>
+#include <fstream>
+#include <stdint.h>
+
+using namespace std;
+
+#include "features.h"
+
+class PixelMaps {
+public:
+ unsigned int _nb_ref;
+ unsigned char *_core;
+ PixelMaps(int size);
+ ~PixelMaps();
+ PixelMaps *add_ref();
+ void del_ref();
+};
+
+class ImageSet {
+ int _nb_pics, _nb_obj;
+ int _width, _height;
+ PixelMaps *_pixel_maps;
+ unsigned char **_pixels, *_labels;
+ bool *_used_picture;
+
+public:
+ ImageSet();
+ ~ImageSet();
+
+ inline int nb_pics() { return _nb_pics; }
+ inline int nb_obj() { return _nb_obj; }
+ inline int width() { return _width; }
+ inline int height() { return _height; }
+ inline unsigned char *pixels(int p) { return _pixels[p]; }
+ inline unsigned char pixel(int p, int x, int y) { return _pixels[p][x + y * _width]; }
+ inline unsigned char label(int p) { return _labels[p]; }
+
+ void reset_used_pictures();
+ int nb_unused_pictures();
+ int pick_unused_picture();
+
+ void load_mnist_format(char *picture_file_name, char *label_file_name);
+
+ void extract_unused_pictures(ImageSet &is, int nb);
+
+};
+
+#endif
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+// $Id: misc.cc,v 1.1 2005-12-13 17:19:11 fleuret Exp $
+
+#include "misc.h"
+
+int compare_couple(const void *a, const void *b) {
+ if(((Couple *) a)->value < ((Couple *) b)->value) return -1;
+ else if(((Couple *) a)->value > ((Couple *) b)->value) return 1;
+ else return 0;
+}
+
+int factorial(int k) {
+ int n = 1;
+ for(int l = 1; l <= k; l++) n *= l;
+ return n;
+}
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#ifndef MISC_H
+#define MISC_H
+
+#ifdef DEBUG
+#define ASSERT(x, s) if(!(x)) { std::cerr << "ASSERT FAILED IN " << __FILE__ << ":" << __LINE__ << " [" << (s) << "]\n"; abort(); }
+#else
+#define ASSERT(x, s)
+#endif
+
+typedef float scalar_t;
+
+template<class T> T sq(T x) { return x*x; }
+
+template<class T> T pos(T x) { if(x < 0) return 0.0; else return x; }
+
+struct Couple {
+ int index;
+ double value;
+};
+
+int compare_couple(const void *a, const void *b);
+
+int factorial(int k);
+
+#endif
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <string.h>
+
+#include "neural.h"
+
+const scalar_t MultiLayerPerceptron::output_amplitude = 0.95;
+
+// I won't comment the natural elegance of C++ in that kind of
+// situation. IT SUCKS.
+
+MultiLayerPerceptron::MultiLayerPerceptron(const MultiLayerPerceptron &mlp) {
+ _nb_layers = mlp._nb_layers;
+ _layer_sizes = new int[_nb_layers];
+ _frozen_layers = new bool[_nb_layers-1];
+ memcpy((void *) _frozen_layers, (void *) mlp._frozen_layers, _nb_layers * sizeof(bool));
+ _activations_index = new int[_nb_layers];
+ _weights_index = new int[_nb_layers];
+
+ _nb_activations = 0;
+ _nb_weights = 0;
+
+ for(int n = 0; n < _nb_layers; n++) _layer_sizes[n] = mlp._layer_sizes[n];
+
+ for(int n = 0; n < _nb_layers; n++) {
+ _activations_index[n] = _nb_activations;
+ _nb_activations += _layer_sizes[n];
+ if(n < _nb_layers - 1) {
+ _frozen_layers[n] = false;
+ _weights_index[n] = _nb_weights;
+ _nb_weights += (_layer_sizes[n] + 1) * _layer_sizes[n+1];
+ }
+ }
+
+ _activations = new scalar_t[_nb_activations];
+ _pre_sigma_activations = new scalar_t[_nb_activations];
+
+ _weights = new scalar_t[_nb_weights];
+ memcpy((void *) _weights, (void *) mlp._weights, _nb_weights * sizeof(scalar_t));
+}
+
+MultiLayerPerceptron::MultiLayerPerceptron(int nb_layers, int *layer_sizes) {
+ _nb_layers = nb_layers;
+ _layer_sizes = new int[_nb_layers];
+ _frozen_layers = new bool[_nb_layers-1];
+ _activations_index = new int[_nb_layers];
+ _weights_index = new int[_nb_layers];
+
+ _nb_activations = 0;
+ _nb_weights = 0;
+
+ for(int n = 0; n < _nb_layers; n++) _layer_sizes[n] = layer_sizes[n];
+
+ for(int n = 0; n < _nb_layers; n++) {
+ _activations_index[n] = _nb_activations;
+ _nb_activations += _layer_sizes[n];
+ if(n < _nb_layers - 1) {
+ _frozen_layers[n] = false;
+ _weights_index[n] = _nb_weights;
+ _nb_weights += (_layer_sizes[n] + 1) * _layer_sizes[n+1];
+ }
+ }
+
+ _activations = new scalar_t[_nb_activations];
+ _pre_sigma_activations = new scalar_t[_nb_activations];
+
+ _weights = new scalar_t[_nb_weights];
+}
+
+MultiLayerPerceptron::MultiLayerPerceptron(istream &is) {
+ is >> _nb_layers;
+
+ _layer_sizes = new int[_nb_layers];
+ _frozen_layers = new bool[_nb_layers - 1];
+ _activations_index = new int[_nb_layers];
+ _weights_index = new int[_nb_layers];
+
+ _nb_activations = 0;
+ _nb_weights = 0;
+
+ for(int n = 0; n < _nb_layers; n++) is >> _layer_sizes[n];
+
+ for(int n = 0; n < _nb_layers; n++) {
+ _activations_index[n] = _nb_activations;
+ _nb_activations += _layer_sizes[n];
+ if(n < _nb_layers - 1) {
+ _frozen_layers[n] = false;
+ _weights_index[n] = _nb_weights;
+ _nb_weights += (_layer_sizes[n] + 1) * _layer_sizes[n+1];
+ }
+ }
+
+ _activations = new scalar_t[_nb_activations];
+ _pre_sigma_activations = new scalar_t[_nb_activations];
+
+ _weights = new scalar_t[_nb_weights];
+
+ for(int l = 0; l < _nb_layers - 1; l++) {
+ int ll;
+ is >> ll;
+ if(l != ll) {
+ cerr << "Inconsistent layer number during loading!\n";
+ cerr.flush();
+ exit(1);
+ }
+ for(int j = 0; j < _layer_sizes[l]; j++)
+ for(int i = 0; i < _layer_sizes[l+1]; i++)
+ is >> _weights[_weights_index[l] + i * (_layer_sizes[l] + 1) + j];
+ }
+}
+
+MultiLayerPerceptron::~MultiLayerPerceptron() {
+ delete[] _weights;
+ delete[] _activations;
+ delete[] _pre_sigma_activations;
+
+ delete[] _layer_sizes;
+ delete[] _frozen_layers;
+ delete[] _weights_index;
+ delete[] _activations_index;
+}
+
+void MultiLayerPerceptron::save(ostream &os) {
+ os << _nb_layers << "\n";
+ for(int n = 0; n < _nb_layers; n++) os << _layer_sizes[n] << (n < _nb_layers - 1 ? " " : "\n");
+ for(int l = 0; l < _nb_layers - 1; l++) {
+ os << l << "\n";
+ for(int j = 0; j < _layer_sizes[l]; j++) {
+ for(int i = 0; i < _layer_sizes[l+1]; i++)
+ os << _weights[_weights_index[l] + i * (_layer_sizes[l] + 1) + j] << (i < _layer_sizes[l+1] - 1 ? " " : "\n");
+ }
+ }
+}
+
+void MultiLayerPerceptron::save_data() {
+ for(int i = 0; i < _layer_sizes[1]; i++) {
+ char buffer[256];
+ sprintf(buffer, "/tmp/hidden_%03d.dat", i);
+ ofstream stream(buffer);
+ for(int j = 0; j < _layer_sizes[0]; j++) {
+ if(j%28 == 0) stream << "\n";
+ stream << j%28 << " " << j/28 << " " << _weights[i * (_layer_sizes[0] + 1) + j] << "\n";
+ }
+ }
+}
+
+void MultiLayerPerceptron::init_random_weights(scalar_t stdd) {
+ for(int w = 0; w < _nb_weights; w++) _weights[w] = normal_sample() * stdd;
+}
+
+void MultiLayerPerceptron::compute_gradient_1s(ImageSet *is, int p, scalar_t *gradient_1s) {
+ scalar_t dactivations[_nb_activations];
+
+ compute_activations_1s(is, p);
+
+ int nb_unfrozen = 0;
+ for(int l = 0; l < _nb_layers - 1; l++) if(!_frozen_layers[l]) nb_unfrozen++;
+
+ for(int i = 0; i < _layer_sizes[_nb_layers - 1]; i++) {
+ scalar_t correct;
+ if(is->label(p) == i) correct = output_amplitude;
+ else correct = - output_amplitude;
+ dactivations[_activations_index[_nb_layers - 1] + i] = 2 * (_activations[_activations_index[_nb_layers - 1] + i] - correct);
+ }
+
+ for(int l = _nb_layers - 2; (l >= 0) && (nb_unfrozen > 0); l--) {
+ int ai0 = _activations_index[l], ai1 = _activations_index[l+1],
+ wi0 = _weights_index[l], ls0p1 = _layer_sizes[l] + 1;
+
+ int j;
+ for(j = 0; j < _layer_sizes[l]; j++) {
+ scalar_t s = 0.0;
+ for(int i = 0; i < _layer_sizes[l+1]; i++) {
+ scalar_t alpha = dactivations[ai1 + i] * dsigma(_pre_sigma_activations[ai1 + i]);
+ s += alpha * _weights[wi0 + i * ls0p1 + j];
+ gradient_1s[wi0 + i * ls0p1 + j] = alpha * _activations[ai0 + j];
+ }
+ dactivations[ai0 + j] = s;
+ }
+
+ for(int i = 0; i < _layer_sizes[l+1]; i++) {
+ scalar_t alpha = dactivations[ai1 + i] * dsigma(_pre_sigma_activations[ai1 + i]);
+ gradient_1s[wi0 + i * ls0p1 + j] = alpha;
+ }
+ if(!_frozen_layers[l]) nb_unfrozen--;
+ }
+}
+
+void MultiLayerPerceptron::compute_gradient(ImageSet *is, scalar_t *gradient) {
+ scalar_t gradient_1s[_nb_weights];
+ for(int w = 0; w < _nb_weights; w++) gradient[w] = 0.0;
+ for(int p = 0; p < is->nb_pics(); p++) {
+ compute_gradient_1s(is, p, gradient_1s);
+ for(int w = 0; w < _nb_weights; w++) gradient[w] += gradient_1s[w];
+ }
+}
+
+void MultiLayerPerceptron::compute_numerical_gradient(ImageSet *is, scalar_t *gradient) {
+ const scalar_t eps = 1e-3;
+ scalar_t error_plus, error_minus, ref;
+ for(int w = 0; w < _nb_weights; w++) {
+ ref = _weights[w];
+ _weights[w] = ref + eps;
+ error_plus = error(is);
+ _weights[w] = ref - eps;
+ error_minus = error(is);
+ _weights[w] = ref;
+ gradient[w] = (error_plus - error_minus) / (2 * eps);
+ }
+}
+
+void MultiLayerPerceptron::print_gradient(ostream &os, scalar_t *gradient) {
+ for(int w = 0; w < _nb_weights; w++) os << gradient[w] << "\n";
+}
+
+void MultiLayerPerceptron::move_on_line(scalar_t *origin, scalar_t *gradient, scalar_t lambda) {
+ for(int l = 0; l < _nb_layers-1; l++) if(!_frozen_layers[l]) {
+ for(int i = 0; i < (_layer_sizes[l] + 1) * _layer_sizes[l+1]; i++)
+ _weights[_weights_index[l] + i] =
+ origin[_weights_index[l] + i] + lambda * gradient[_weights_index[l] + i];
+ }
+}
+
+void MultiLayerPerceptron::one_step_basic_gradient(ImageSet *is, scalar_t dt) {
+ scalar_t gradient_1s[_nb_weights];
+ for(int p = 0; p < is->nb_pics(); p++) {
+ if(p%1000 == 0) {
+ int n = (p*50)/is->nb_pics();
+ int j;
+ for(j = 0; j < n; j++) cout << "X";
+ for(; j < 50; j++) cout << ((j%5 == 0) ? "+" : "-");
+ cout << "\r";
+ cout.flush();
+ }
+ compute_gradient_1s(is, p, gradient_1s);
+ move_on_line(_weights, gradient_1s, -dt);
+ }
+ cout << " \r"; cout.flush();
+}
+
+void MultiLayerPerceptron::one_step_global_gradient(ImageSet *is, scalar_t *xi, scalar_t *g, scalar_t *h) {
+ scalar_t origin[_nb_weights];
+ for(int w = 0; w < _nb_weights; w++) origin[w] = _weights[w];
+
+ scalar_t l = 1e-8;
+ scalar_t e, pe;
+
+ e = error(is);
+
+ do {
+ pe = e;
+ l *= 2;
+ move_on_line(origin, xi, l);
+ e = error(is);
+ } while(e < pe);
+
+ scalar_t dl = - l / 4;
+
+ while(abs(dl) > 1e-6) {
+ move_on_line(origin, xi, l);
+ e = error(is);
+ do {
+ pe = e;
+ l += dl;
+ move_on_line(origin, xi, l);
+ e = error(is);
+ } while(e < pe);
+ dl = - dl / 4;
+ }
+
+ compute_gradient(is, xi);
+
+ scalar_t gg = 0, gxi = 0, xixi = 0;
+
+ // Polak-Ribiere
+
+ for(int w = 0; w < _nb_weights; w++) {
+ gg += sq(g[w]);
+ gxi += g[w] * xi[w];
+ xixi += sq(xi[w]);
+ }
+
+ scalar_t gamma = (xixi + gxi)/gg;
+
+ // Set gamma to 0 for standard gradient descente
+ // gamma = 0.0;
+
+ for(int w = 0; w < _nb_weights; w++) {
+ g[w] = -xi[w];
+ h[w] = g[w] + gamma * h[w];
+ xi[w] = h[w];
+ }
+}
+
+void MultiLayerPerceptron::train(ImageSet *training_set, ImageSet *validation_set) {
+ scalar_t prev_validation_error = 1.0, validation_error = 1.0, training_error;
+ int l = 0, nb_increases = 0;
+ do {
+// #warning horrible debugging
+// {
+// char buffer[1024];
+// sprintf(buffer, "tmp_%04d.mlp", l);
+// ofstream stream(buffer);
+// save(stream);
+// stream.flush();
+// }
+ prev_validation_error = validation_error;
+ // one_step_global_gradient(training_set, xi, g, h);
+ one_step_basic_gradient(training_set, 1e-2);
+ training_error = error(training_set);
+ validation_error = error(validation_set);
+ cout << l
+ << " TRAINING " << training_error << " (" << classification_error(training_set)*100 << "%)"
+ << " VALIDATION " << validation_error << " (" << classification_error(validation_set)*100 << "%)";
+ if(l > 0 && validation_error >= prev_validation_error) {
+ nb_increases++;
+ cout << " [" << nb_increases << "]";
+ }
+ cout << "\n";
+ cout.flush();
+ l++;
+ } while(nb_increases < 10);
+
+}
+
+void MultiLayerPerceptron::compute_activations_1s(ImageSet *is, int p) {
+ ASSERT(_layer_sizes[0] == is->width() * is->height(), "The first layer has to have as many units as there are pixels!");
+
+ scalar_t *a = _activations;
+ scalar_t *w = _weights;
+
+ for(int y = 0; y < is->height(); y++) for(int x = 0; x < is->width(); x++)
+ *(a++) = 2.0 * (scalar_t(is->pixel(p, x, y)) / 255.0) - 1.0;
+
+ scalar_t *pa = _pre_sigma_activations + _activations_index[1];
+ scalar_t *b = _activations, *b2 = 0;
+
+ for(int l = 0; l < _nb_layers - 1; l++) {
+ for(int i = 0; i < _layer_sizes[l+1]; i++) {
+ scalar_t s = 0;
+ b2 = b;
+ for(int j = 0; j < _layer_sizes[l]; j++) s += *(w++) * *(b2++);
+ s += *(w++);
+ *(pa++) = s;
+ *(a++) = sigma(s);
+ }
+ b = b2;
+ }
+}
+
+void MultiLayerPerceptron::test(ImageSet *is, scalar_t *responses) {
+ for(int p = 0; p < is->nb_pics(); p++) {
+ compute_activations_1s(is, p);
+ for(int i = 0; i < _layer_sizes[_nb_layers - 1]; i++)
+ responses[p * _layer_sizes[_nb_layers - 1] + i] = _activations[_activations_index[_nb_layers - 1] + i];
+ }
+}
+
+scalar_t MultiLayerPerceptron::error(ImageSet *is) {
+ scalar_t error = 0;
+
+ for(int p = 0; p < is->nb_pics(); p++) {
+ compute_activations_1s(is, p);
+ for(int i = 0; i < _layer_sizes[_nb_layers - 1]; i++) {
+ scalar_t correct;
+ if(is->label(p) == i) correct = output_amplitude;
+ else correct = - output_amplitude;
+ error += sq(_activations[_activations_index[_nb_layers - 1] + i] - correct);
+ }
+ }
+
+ return error;
+}
+
+scalar_t MultiLayerPerceptron::classification_error(ImageSet *is) {
+ int nb_error = 0;
+
+ for(int p = 0; p < is->nb_pics(); p++) {
+ compute_activations_1s(is, p);
+ scalar_t max = -1;
+ int i_max = -1;
+ for(int i = 0; i < _layer_sizes[_nb_layers - 1]; i++) {
+ if(i_max < 0 || _activations[_activations_index[_nb_layers - 1] + i] > max) {
+ i_max = i;
+ max = _activations[_activations_index[_nb_layers - 1] + i];
+ }
+ }
+ if(is->label(p) != i_max) nb_error++;
+ }
+
+ return scalar_t(nb_error)/scalar_t(is->nb_pics());
+}
--- /dev/null
+/*
+ * mlp-mnist is an implementation of a multi-layer neural network.
+ *
+ * Copyright (c) 2008 Idiap Research Institute, http://www.idiap.ch/
+ * Written by Francois Fleuret <francois.fleuret@idiap.ch>
+ *
+ * This file is part of mlp-mnist.
+ *
+ * mlp-mnist is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * mlp-mnist is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with mlp-mnist. If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#ifndef NEURAL_H
+#define NEURAL_H
+
+#include <cmath>
+#include <stdlib.h>
+
+#include "misc.h"
+#include "images.h"
+
+inline scalar_t normal_sample() {
+ scalar_t a = drand48();
+ scalar_t b = drand48();
+ return cos(2 * M_PI * a) * sqrt(-2 * log(b));
+}
+
+class MultiLayerPerceptron {
+protected:
+ static const scalar_t output_amplitude;
+
+ int _nb_layers;
+ int *_layer_sizes;
+ int _nb_activations, _nb_weights;
+
+ // We can 'freeze' certain layers and let the learning only change
+ // the others
+ bool *_frozen_layers;
+
+ // Tell us where the layers begin
+ int *_weights_index, *_activations_index;
+
+ scalar_t *_activations, *_pre_sigma_activations;
+ scalar_t *_weights;
+
+public:
+ MultiLayerPerceptron(const MultiLayerPerceptron &mlp);
+ MultiLayerPerceptron(int nb_layers, int *layer_sizes);
+ MultiLayerPerceptron(istream &is);
+ ~MultiLayerPerceptron();
+
+ void save(ostream &os);
+
+ void save_data();
+
+ inline int nb_layers() { return _nb_layers; }
+ inline int layer_size(int l) { return _layer_sizes[l]; }
+ inline int nb_weights() { return _nb_weights; }
+ inline void freeze(int l, bool f) { _frozen_layers[l] = f; }
+ scalar_t sigma(scalar_t x) { return 2 / (1 + exp(- x)) - 1; }
+ scalar_t dsigma(scalar_t x) { scalar_t e = exp(- x); return 2 * e / sq(1 + e); }
+
+ // Init all the weights with a normal distribution of given standard
+ // deviation
+ void init_random_weights(scalar_t stdd);
+
+ // Compute the gradient based on one single sample
+ void compute_gradient_1s(ImageSet *is, int p, scalar_t *gradient_1s);
+ // Compute the gradient based on all samples from the set
+ void compute_gradient(ImageSet *is, scalar_t *gradient);
+
+ // Compute the same gradient numerically (to check the one above)
+ void compute_numerical_gradient(ImageSet *is, scalar_t *gradient);
+
+ // Print the gradient
+ void print_gradient(ostream &os, scalar_t *gradient);
+
+ // Move all weights to origin + lambda * gradient
+ void move_on_line(scalar_t *origin, scalar_t *gradient, scalar_t lambda);
+
+ // The 'basic' gradient just goes through all samples and add dt
+ // time the gradient on each one
+ void one_step_basic_gradient(ImageSet *is, scalar_t dt);
+
+ // The global gradient uses a conjugate gradient to minmize the
+ // global quadratic error
+ void one_step_global_gradient(ImageSet *is, scalar_t *xi, scalar_t *g, scalar_t *h);
+
+ // Performs gradient descent until the test error as increased
+ // during 5 steps
+ void train(ImageSet *training_set, ImageSet *validation_set);
+
+ // Compute the activation of the network from one sample. The input
+ // layer has to be as large as the number of pixels in the images.
+ void compute_activations_1s(ImageSet *is, int p);
+
+ // Compute the activation of the network on all samples. The
+ // responses array has to be as large as the number of samples in is
+ // time the dimension of the output layer
+ void test(ImageSet *is, scalar_t *responses);
+
+ // Compute the quadratic error
+ scalar_t error(ImageSet *is);
+ // Compute the classification error
+ scalar_t classification_error(ImageSet *is);
+};
+
+#endif